<?php

namespace Drupal\jsonapi_hypermedia;

/**
 * Interface LinkProviderInterface.
 *
 * @see \Drupal\jsonapi_hypermedia\Plugin\LinkProviderBase;
 */
interface LinkProviderInterface {

  /**
   * Gets the link object key for the provided link.
   *
   * @return string
   */
  public function getLinkKey();

  /**
   * Adds, alters or removes hyperlinks from a link collection.
   *
   * @param mixed $context
   *   The context object from which links should be generated.
   *
   * @return \Drupal\jsonapi_hypermedia\AccessRestrictedLink
   *   A link to be added to the context object. An AccessRestrictedLink
   *   should be returned if the link target may be inaccessible to some users.
   *
   * @todo: Change the parameter type hint to \Drupal\jsonapi\JsonApiResource\JsonApiDocumentTopLevel|\Drupal\jsonapi\JsonApiResource\ResourceObject|\Drupal\jsonapi\JsonApiResource\Relationship once https://www.drupal.org/project/drupal/issues/3036285 lands.
   */
  public function getLink($context);

}
