<?php

namespace Drupal\jsonapi_hypermedia\Plugin;

use Drupal\Component\Plugin\Discovery\CachedDiscoveryInterface;
use Drupal\Component\Plugin\PluginManagerInterface;

/**
 * Interface LinkProviderManagerInterface.
 *
 * @see \Drupal\jsonapi_hypermedia\Annotation\JsonapiHypermediaLinkProvider
 * @see \Drupal\jsonapi_hypermedia\Plugin\LinkProviderManager
 * @see \Drupal\jsonapi_hypermedia\LinkProviderInterface
 *
 * @internal
 */
interface LinkProviderManagerInterface extends PluginManagerInterface, CachedDiscoveryInterface {

  /**
   * Gets a LinkCollection of 3rd-party links for the given context object.
   *
   * @param mixed $context
   *   The link context object.
   *
   * @return \Drupal\jsonapi\JsonApiResource\LinkCollection
   *   The link collection.
   *
   * @todo: Change the parameter type hint to \Drupal\jsonapi\JsonApiResource\JsonApiDocumentTopLevel|\Drupal\jsonapi\JsonApiResource\ResourceObject|\Drupal\jsonapi\JsonApiResource\Relationship once https://www.drupal.org/project/drupal/issues/3036285 lands.
   */
  public function getLinkCollection($context);

}
